// ConflictEditorDoc.h : interface of the ConflictEditorDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFLICTEDITORDOC_H__8980EBF3_FDF8_44C2_9291_CBEEF52BDB9A__INCLUDED_)
#define AFX_CONFLICTEDITORDOC_H__8980EBF3_FDF8_44C2_9291_CBEEF52BDB9A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <memory>
#include <string>
#include "ConflictTextBufferListener.h"
class ConflictTextBuffer;
class ConflictBlock;
class ConflictEditorView;


class ConflictEditorDoc : public CDocument, 
                          public ConflictTextBufferListener
{
protected: // create from serialization only
	ConflictEditorDoc();
	DECLARE_DYNCREATE(ConflictEditorDoc)

public:
  ConflictTextBuffer *targetTextBuffer();
  ConflictTextBuffer *mergedTextBuffer();
  int currentConflictIndex();
  
  // ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ConflictEditorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

	virtual ~ConflictEditorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	//{{AFX_MSG(ConflictEditorDoc)
	afx_msg void OnNextConflict();
	afx_msg void OnUpdateNextConflict(CCmdUI* pCmdUI);
	afx_msg void OnPreviousConflict();
	afx_msg void OnUpdatePreviousConflict(CCmdUI* pCmdUI);
	afx_msg void OnFirstConflict();
	afx_msg void OnUpdateFirstConflict(CCmdUI* pCmdUI);
	afx_msg void OnLastConflict();
	afx_msg void OnUpdateLastConflict(CCmdUI* pCmdUI);
	afx_msg void OnCurrentConflict();
	afx_msg void OnUpdateCurrentConflict(CCmdUI* pCmdUI);
	afx_msg void OnInsertMergedBeforeTarget();
	afx_msg void OnUpdateInsertMergedBeforeTarget(CCmdUI* pCmdUI);
	afx_msg void OnInsertMergedAfterTarget();
	afx_msg void OnUpdateInsertMergedAfterTarget(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
  void textBufferModified( ConflictTextBuffer *buffer,
                           bool bIsModified );

  void scrollViewsToCurrentConflict();

  int conflictCount();

  void addMergedRevisionToTitle( std::string mergedRevision );

  ConflictBlock *targetConflictAt( int nConflictIndex );
  ConflictBlock *mergedConflictAt( int nConflictIndex );

  ConflictEditorView *targetView();

  ConflictTextBuffer *m_pTargetTextBuffer;
  ConflictTextBuffer *m_pMergedTextBuffer;
  int m_nCurrentConflictIndex;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFLICTEDITORDOC_H__8980EBF3_FDF8_44C2_9291_CBEEF52BDB9A__INCLUDED_)
