// //////////////////////////////////////////////////////////////////////////
// Header file ConflictEditorUpdateContext.h for class ConflictEditorUpdateContext
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/17
// //////////////////////////////////////////////////////////////////////////
#ifndef CONFLICTEDITORUPDATECONTEXT_H
#define CONFLICTEDITORUPDATECONTEXT_H

/*! \class ConflictEditorUpdateContext
 * \brief This class represents an update context.
 */
class ConflictEditorUpdateContext : public CObject
{
public:
  /*! Constructs a ConflictEditorUpdateContext object.
   */
  ConflictEditorUpdateContext( int nConflictNumber );

  /*! Destructor.
   */
  virtual ~ConflictEditorUpdateContext();

  int focusConflictNumber();

private:
  /// Prevents the use of the copy constructor.
  ConflictEditorUpdateContext( const ConflictEditorUpdateContext &copy );

  /// Prevents the use of the copy operator.
  void operator =( const ConflictEditorUpdateContext &copy );

private:
  int m_nConflictNumber;
};



// Inlines methods for ConflictEditorUpdateContext:
// ------------------------------------------------



#endif  // CONFLICTEDITORUPDATECONTEXT_H
