// ConflictEditorView.h : interface of the ConflictEditorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFLICTEDITORVIEW_H__DD73B494_D4FD_4668_B6CF_0D7C1574E9EA__INCLUDED_)
#define AFX_CONFLICTEDITORVIEW_H__DD73B494_D4FD_4668_B6CF_0D7C1574E9EA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CrystalEdit/CrystalEditViewEx.h"
class ConflictEditorDoc;
class CCrystalParser;
class ConflictMarginDrawer;
class ConflictTextBuffer;
class ConflictList;
class ConflictEditorUpdateContext;


class ConflictEditorView : public CCrystalEditViewEx
{
protected: // create from serialization only
	ConflictEditorView();
	DECLARE_DYNCREATE(ConflictEditorView)

public:
	ConflictEditorDoc* document();

  void SetTargetView();
  void SetMergedView();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ConflictEditorView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

	virtual ~ConflictEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(ConflictEditorView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP();

protected:
  virtual CCrystalTextBuffer *LocateTextBuffer();
  virtual void DrawMargin (CDC * pdc, const CRect & rect, int nLineIndex);

  ConflictTextBuffer *textBuffer();
  ConflictList *conflicts();
  void updateView( ConflictEditorUpdateContext *pContext );

private:
  CCrystalParser *m_pParser;
  LOGFONT m_font;
  ConflictMarginDrawer *m_pMarginDrawer;
  bool m_bIsTargetView;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFLICTEDITORVIEW_H__DD73B494_D4FD_4668_B6CF_0D7C1574E9EA__INCLUDED_)
