// //////////////////////////////////////////////////////////////////////////
// Header file ConflictTextBuffer.h for class ConflictTextBuffer
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/15
// //////////////////////////////////////////////////////////////////////////
#ifndef CONFLICTTEXTBUFFER_H
#define CONFLICTTEXTBUFFER_H

#include "CrystalEdit/CCrystalTextBuffer.h"
#include <vector>
class ConflictTextBufferListener;
class ConflictList;


/*! \class ConflictTextBuffer
 * \brief This class represents a text buffer for a conflict file.
 */
class ConflictTextBuffer : public CCrystalTextBuffer
{
public:
  /*! Constructs a ConflictTextBuffer object.
   */
  ConflictTextBuffer( ConflictTextBufferListener *listener );

  /*! Destructor.
   */
  virtual ~ConflictTextBuffer();

  virtual void SetModified( BOOL bModified = TRUE );

  ConflictList *conflicts();

  void insertLoadedLine( std::string line );

protected:
  virtual void lineInsertedAt( int nLineIndex );
  virtual void linesDeletedAt( int nLineIndex, 
                               int nNumberOfLines );

private:
  /// Prevents the use of the copy constructor.
  ConflictTextBuffer( const ConflictTextBuffer &copy );

  /// Prevents the use of the copy operator.
  void operator =( const ConflictTextBuffer &copy );


private:
  ConflictTextBufferListener *m_listener;
  ConflictList *m_pConflicts;
  bool m_bIsLoading;
};



// Inlines methods for ConflictTextBuffer:
// ---------------------------------------



#endif  // CONFLICTTEXTBUFFER_H
