// //////////////////////////////////////////////////////////////////////////
// Header file DosLineReader.h for class DosLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////
#ifndef DOSLINEREADER_H
#define DOSLINEREADER_H

#include "LineReader.h"


/*! \class DosLineReader
 * \brief This class represents a line reader for DOS file.
 */
class DosLineReader : public LineReader
{
public:
  /*! Constructs a DosLineReader object.
   */
  DosLineReader( CFile *pFile );

  /*! Destructor.
   */
  virtual ~DosLineReader();

  virtual void setEndOfLineType( ConflictTextBuilder *pBuffer );
  virtual std::string readLine();

private:
  /// Prevents the use of the copy constructor.
  DosLineReader( const DosLineReader &copy );

  /// Prevents the use of the copy operator.
  void operator =( const DosLineReader &copy );

private:
};



// Inlines methods for DosLineReader:
// ----------------------------------



#endif  // DOSLINEREADER_H
