// //////////////////////////////////////////////////////////////////////////
// Implementation file UnixLineReader.cpp for class UnixLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "UnixLineReader.h"
#include "ConflictTextBuilder.h"


UnixLineReader::UnixLineReader( CFile *pFile ) : 
    LineReader( pFile )
{
}


UnixLineReader::~UnixLineReader()
{
}


void 
UnixLineReader::setEndOfLineType( ConflictTextBuilder *pBuffer )
{
  pBuffer->setEndOfLineUnix();
}


std::string 
UnixLineReader::readLine()
{
  std::string line;
  char nextChar;
  try
  {
    m_archive >> nextChar;
    while ( nextChar != 10 )
    {
      line += nextChar;
      m_archive >> nextChar;
    }
  }
  catch ( CArchiveException *e )
  {
    e->Delete();
    if ( line.empty() )
      throw NoMoreLine();
  }
  return line;
}

